/****************************************Copyright (c)****************************************************
**                                6lowpan߿ƽ̨
**                                  һΪԴӦö
**
**
**--------------File Info---------------------------------------------------------------------------------
** File Name:           arch_io_dma.c
** Last modified Date:  2013-04-23
** Last Version:        v1.0
** Description:         dmaģĴװʵ
**
**--------------------------------------------------------------------------------------------------------
** Created By:          Renhaiboκ
** Created date:        2013-04-23
** Version:             v1.0
** Descriptions:        The original version ʼ汾
**
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
** Version:
** Description:
**
*********************************************************************************************************/
#include "hal/arch/inc/arch_io_memmap.h"
#include "hal/arch/inc/arch_io_reg.h"
#include "hal/arch/inc/arch_io_dma.h"


/*********************************************************************************************************
** Function name:       DMAModeSet
** Descriptions:        DMAģ鹤ģʽ
** input parameters:    ulBase          DMAģĻַ
**                      ucChannel       DMAͨţDMA1Ϊ1-7DMA2Ϊ1-5
**                      ucConfig        DMAòȡмĻ
**                      DMA_DIR_M_READ            //  Ӵ洢֮Ϊ
**                      DMA_CIRC_EN               //  ִѭģʽ
**                      DMA_PINC_EN               //  ʹַģʽ
**                      DMA_MINC_EN               //  ʹܴ洢ַģʽ
**                      //  ĸȡеһֵл
**                      DMA_PSIZE_8               //  ݿΪ8λ
**                      DMA_PSIZE_16              //  ݿΪ16λ
**                      DMA_PSIZE_32              //  ݿΪ32λ
**                      DMA_PSIZE_RESERVED        //  ݿȱ
**                      //  ĸȡеһֵл
**                      DMA_MSIZE_8               //  洢ݿΪ8λ
**                      DMA_MSIZE_16              //  洢ݿΪ16λ
**                      DMA_MSIZE_32              //  洢ݿΪ32λ
**                      DMA_MSIZE_RESERVED        //  洢ݿȱ
**                      //  ĸȡеһֵл
**                      DMA_PL_LOW                //  ͨȼΪ
**                      DMA_PL_MEDIUM             //  ͨȼΪ
**                      DMA_PL_HIGH               //  ͨȼΪ
**                      DMA_PL_HITHEST            //  ͨȼΪ
**
**                      DMA_MTOM_EN               //  洢洢ģʽʹ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void DMAModeSet(unsigned long ulBase, unsigned char ucChannel,unsigned long ulConfig)
{
    unsigned long ulTemp;
    ulTemp = HWREG32(ulBase + DMA_O_CCR1 + (ucChannel-1)*0x14);
    ulTemp &= 0xFFFF800F;
    ulTemp |= ulConfig;
    HWREG32(ulBase + DMA_O_CCR1+ (ucChannel-1)*0x14)= ulTemp;
}

/*********************************************************************************************************
** Function name:       DMAAddrSet
** Descriptions:        DMA洢ַַ
** input parameters:    ulBase          DMAģĻַ
**                      ucChannel       DMAͨţDMA1Ϊ1-7DMA2Ϊ1-5
**                      ulMemAddr       ָDMAĴ洢ַ
**                      ulPeriAddr      ָDMAַ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void DMAAddrSet(unsigned long ulBase, unsigned char ucChannel, 
                unsigned long ulMemAddr, unsigned long ulPeriAddr)
{
    HWREG32(ulBase + DMA_O_CPAR1 + (ucChannel-1)*0x14)= ulPeriAddr;
    HWREG32(ulBase + DMA_O_CMAR1 + (ucChannel-1)*0x14)= ulMemAddr;
}

/*********************************************************************************************************
** Function name:       DMABufferSizeSet
** Descriptions:        DMAģ鴫ݻС
** input parameters:    ulBase          DMAģĻַ
**                      ucChannel       DMAͨţDMA1Ϊ1-7DMA2Ϊ1-5
**                      usSize          ָĴС
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void DMABufferSizeSet(unsigned long ulBase, unsigned char ucChannel, unsigned short usSize)
{
    HWREG32(ulBase + DMA_O_CNDTR1 + (ucChannel-1)*0x14)= usSize;
}

/*********************************************************************************************************
** Function name:       DMAEnable
** Descriptions:        DMAģʹ
** input parameters:    ulBase          DMAģĻַ
**                      ucChannel       DMAͨţDMA1Ϊ1-7DMA2Ϊ1-5
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void DMAEnable(unsigned long ulBase, unsigned char ucChannel)
{
    HWREG32(ulBase + DMA_O_CCR1 + (ucChannel-1)*0x14) |= 0x00000001;
}

/*********************************************************************************************************
** Function name:       DMAModeSet
** Descriptions:        DMAģ
** input parameters:    ulBase          DMAģĻַ
**                      ucChannel       DMAͨţDMA1Ϊ1-7DMA2Ϊ1-5
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void DMADisable(unsigned long ulBase, unsigned char ucChannel)
{
    HWREG32(ulBase + DMA_O_CCR1 + (ucChannel-1)*0x14) &= 0xFFFFFFFE;
}

/*********************************************************************************************************
** Function name:       DMAIntEnable
** Descriptions:        DMAжʹ
** input parameters:    ulBase          DMAģĻַ
**                      ucChannel       DMAͨţDMA1Ϊ1-7DMA2Ϊ1-5
**                      ulFlags         ָʹܵжϣȡֵĻ
**                      DMA_INT_TC      //  ж
**                      DMA_INT_HT      //  һʱж
**                      DMA_INT_TE      //  ж
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void DMAIntEnable(unsigned long ulBase, unsigned char ucChannel,unsigned long ulFlags)
{
    HWREG32(ulBase + DMA_O_CCR1 + (ucChannel-1)*0x14) |= ulFlags;
}

/*********************************************************************************************************
** Function name:       DMAIntDisable
** Descriptions:        DMAжϽ
** input parameters:    ulBase          DMAģĻַ
**                      ucChannel       DMAͨţDMA1Ϊ1-7DMA2Ϊ1-5
**                      ulFlags         ָʹܵжϣȡֵĻ
**                      DMA_INT_TC      //  ж
**                      DMA_INT_HT      //  һʱж
**                      DMA_INT_TE      //  ж
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void DMAIntDisable(unsigned long ulBase, unsigned char ucChannel,unsigned long ulFlags)
{
    HWREG32(ulBase + DMA_O_CCR1 + (ucChannel-1)*0x14) &= ~ulFlags;
}

/*********************************************************************************************************
** Function name:       DMAIntStatus
** Descriptions:        DMAж״̬ȡ
** input parameters:    ulBase          DMAģĻַ
**                      ucChannel       DMAͨţDMA1Ϊ1-7DMA2Ϊ1-5
** output parameters:   NONE
** Returned value:      ǰͨж״̬ΪֵDMA_INT_GLOBALĻ
**                      DMA_INT_GLOBALʾȫж״ֻ̬Ҫֵһͳ
**                      DMA_INT_TC      //  ж
**                      DMA_INT_HT      //  һʱж
**                      DMA_INT_TE      //  ж
*********************************************************************************************************/
unsigned long DMAIntStatus(unsigned long ulBase, unsigned char ucChannel)
{
    unsigned long ulTemp;
    ulTemp = HWREG32(ulBase + DMA_O_ISR);
    ulTemp >>= (ucChannel - 1);
    
    return (ulTemp);
}

/*********************************************************************************************************
** Function name:       DMAIntStatus
** Descriptions:        DMAжϽ
** input parameters:    ulBase          DMAģĻַ
**                      ucChannel       DMAͨţDMA1Ϊ1-7DMA2Ϊ1-5
**                      ulIntFlags      ǰͨж״̬ΪֵĻDMA_INT_GLOBALĻ
**                      DMA_INT_GLOBALʾȫж״ֻ̬Ҫֵһͳ
**                      DMA_INT_TC      //  ж
**                      DMA_INT_HT      //  һʱж
**                      DMA_INT_TE      //  ж
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void DMAIntClear(unsigned long ulBase, unsigned char ucChannel,unsigned long ulIntFlags)
{
    unsigned long ulTemp = (ulIntFlags << (ucChannel - 1));
    
    HWREG32(ulBase + DMA_O_IFCR) |= ulTemp;
    
}
/*********************************************************************************************************
  END FILE
*********************************************************************************************************/
