/****************************************Copyright (c)****************************************************
**                                6lowpan߿ƽ̨
**                                  һΪԴӦö
**
**
**--------------File Info---------------------------------------------------------------------------------
** File Name:           arch_io_gpio.c
** Last modified Date:  2013-04-02
** Last Version:        v1.0
** Description:         gpioģĴװʵ
**
**--------------------------------------------------------------------------------------------------------
** Created By:          Renhaiboκ
** Created date:        2013-04-02
** Version:             v1.0
** Descriptions:        The original version ʼ汾
**
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
** Version:
** Description:
**
*********************************************************************************************************/
#include "hal/arch/inc/arch_io_memmap.h"
#include "hal/arch/inc/arch_io_reg.h"
#include "hal/arch/inc/arch_io_gpio.h"


/*********************************************************************************************************
** Function name:       GPIOConfigSet
** Descriptions:        GPIO
** input parameters:    ulBase:     GPIOģĻַ
**                      usPin:      ָõ
**                      ulConfig:   õĲ,ȡֵ
**                      // IOΪʱȡֵеһ
**                      GPIO_DIR_IN_Analog      //  ģģʽ
**                      GPIO_DIR_IN_Floating    //  ģʽ
**                      GPIO_DIR_IN_UpDown      //  ģʽ
**
**                      // IOΪʱΪֵĻ
**                      GPIO_OUT_PP             //  ͨģʽ
**                      GPIO_OUT_OD             //  ͨÿ©ģʽ
**                      GPIO_AF_PP              //  ģʽ
**                      GPIO_AF_OD              //  ÿ©ģʽ

**                      GPIO_SPEED_2MHZ         //  ٶΪ2MHz
**                      GPIO_SPEED_10MHZ        //  ٶΪ10MHz
**                      GPIO_SPEED_50MHZ        //  ٶΪ50MHz
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void GPIOConfigSet(unsigned long ulBase, unsigned short usPin, unsigned long ulConfig)
{
    unsigned char i;
    for(i=0; i<8; i++)
    {
        if(usPin & (1<<i))
        {
            HWREG32(ulBase + GPIO_O_CRL) &= ~(0x0F<<(4*i));
            HWREG32(ulBase + GPIO_O_CRL) |= (ulConfig<<(4*i));
            usPin &= ~(1<<i);
        }
        if(!(usPin & 0xFF))
            break;
    }
    
    usPin >>= 8;
    for(i=0; i<8; i++)
    {
        if(usPin & (1<<i))
        {
            HWREG32(ulBase + GPIO_O_CRH) &= ~(0x0F<<(4*i));
            HWREG32(ulBase + GPIO_O_CRH) |= (ulConfig<<(4*i));
            usPin &= ~(1<<i);
        }
        if(!(usPin & 0xFF))
            break;
    }
}

/*********************************************************************************************************
** Function name:       GPIODataPut
** Descriptions:        GPIOú16λʽ
** input parameters:    ulBase:     GPIOģĻַ
**                      usData:     
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void GPIODataPut(unsigned long ulBase, unsigned short usData)
{
    HWREG32(ulBase + GPIO_O_ODR) = usData;
}

/*********************************************************************************************************
** Function name:       GPIODataGet
** Descriptions:        GPIOú16λʽ
** input parameters:    ulBase:     GPIOģĻַ
** output parameters:   NONE
** Returned value:      ȡGPIO˿ڵ
*********************************************************************************************************/
unsigned short GPIODataGet(unsigned long ulBase)
{
    return (HWREG32(ulBase + GPIO_O_IDR));
}

/*********************************************************************************************************
** Function name:       GPIOBitSet
** Descriptions:        GPIOλ
** input parameters:    ulBase:     GPIOģĻַ
**                      usPin:      ָIO
** output parameters:   NONE
** Returned value:      ȡGPIO˿ڵ
*********************************************************************************************************/
void GPIOBitSet(unsigned long ulBase,unsigned short usPin)
{
    HWREG32(ulBase + GPIO_O_BSRR) = usPin;
}

/*********************************************************************************************************
** Function name:       GPIOBitReset
** Descriptions:        GPIOλ
** input parameters:    ulBase:     GPIOģĻַ
**                      usPin:      ָIO
** output parameters:   NONE
** Returned value:      ȡGPIO˿ڵ
*********************************************************************************************************/
void GPIOBitReset(unsigned long ulBase,unsigned short usPin)
{
    HWREG32(ulBase + GPIO_O_BRR) = usPin;
}

/*********************************************************************************************************
** Function name:       GPIOToggleBit
** Descriptions:        תָIO
** input parameters:    u32Base:  ָGPIOģַ
**                      u32Pins ָGPIO
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void GPIOToggleBit(uint32 u32Base, uint32 u32Pins)
{
    HWREG32(u32Base + GPIO_O_ODR) ^= u32Pins;
}
/*********************************************************************************************************
** Function name:       AFIORemapConfig
** Descriptions:        AFIOӳ
** input parameters:    u32Base:     GPIOģĻַ
**                      u32Remap:    Remap
** output parameters:   NONE
** Returned value:      ȡGPIO˿ڵ
*********************************************************************************************************/
void AFIORemapEnable(uint32 u32Remap)
{
    HWREG32(AFIO_BASE + AFIO_O_MAPR) |= u32Remap;
}
/*********************************************************************************************************
** Function name:       AFIORemapReset
** Descriptions:        AFIOӳر
** input parameters:    u32Base:     GPIOģĻַ
**                      u32Remap:    Remap
** output parameters:   NONE
** Returned value:      ȡGPIO˿ڵ
*********************************************************************************************************/
void AFIORemapReset(uint32 u32Remap)
{
    HWREG32(AFIO_BASE + AFIO_O_MAPR) &= ~u32Remap;
}

/*********************************************************************************************************
** Function name:       AFIOExtiLineConfig
** Descriptions:        AFIOж߿
** input parameters:    u32GPIOLinex:   EXTI_GPIO_A....EXTI_GPIO_G
**                      u32Pin:         ָõGPIOţȡ0-15
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void AFIOExtiLineConfig(uint32 u32GPIOLinex, uint32 u32Pin)
{
    uint32 u32Temp = u32Pin / 4;
    uint32 u32Value = u32Pin % 4;

    u32Temp *= 4;
    u32Value *= 4;
    HWREG32(AFIO_BASE + AFIO_O_EXTICR1 + u32Temp) &= ~(((uint32)0x0000000F) << u32Value);
    HWREG32(AFIO_BASE + AFIO_O_EXTICR1 + u32Temp) |= (u32GPIOLinex << u32Value);
}
/*********************************************************************************************************
  END FILE
*********************************************************************************************************/
