/****************************************Copyright (c)****************************************************
**                                6lowpan߿ƽ̨
**                                  һΪԴӦö
**
**
**--------------File Info---------------------------------------------------------------------------------
** File Name:           arch_io_spi.c
** Last modified Date:  2013-04-20
** Last Version:        v1.0
** Description:         spii2sģĴװʵ
**
**--------------------------------------------------------------------------------------------------------
** Created By:          Renhaiboκ
** Created date:        2013-04-20
** Version:             v1.0
** Descriptions:        The original version ʼ汾
**
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
** Version:
** Description:
**
*********************************************************************************************************/
#include "hal/arch/inc/arch_io_memmap.h"
#include "hal/arch/inc/arch_io_reg.h"
#include "hal/arch/inc/arch_io_spi.h"


/*********************************************************************************************************
** Function name:       SPIInit
** Descriptions:        SPIģ鹤ģʽ
** input parameters:    ulBase      SPIģĻַ
**                      ulConfig    SPIģ鹤ģʼãȥмֵĻ
**                      // ģʽѡ
**                      SPI_DIR_2Lines_FullDuplex       //  ȫ˫ģʽ
**                      SPI_DIR_2Lines_RxOnly           //  ֻģʽ
**                      SPI_DIR_1Lines_Rx               //  ֻ
**                      SPI_DIR_1Lines_Tx               //  ֻ
**
**                      //  ѡ
**                      SPI_MODE_Master                 //  SPIģʽ
**                      SPI_MODE_Slave                  //  SPIӻģʽ
**
**                      //  ݳѡ
**                      SPI_DATA_Len8                   //  ݳȳΪ8
**                      SPI_DATA_Len16                  //  ݳΪ16
**
**                      // շʱSPI_CLKѡ
**                      SPI_CPOL_Low                    //  SPI_CLKΪ͵ƽ
**                      SPI_CPOL_High                   //  SPI_CLKΪߵƽ
**
**                      // ʱӲλѡ
**                      SPI_CPHA_1Edge                  //  ڵһʱӱز
**                      SPI_CPHA_2Edge                  //  ڵڶʱӱز
**
**                      // ӻƬѡ
**                      SPI_NSS_Soft                    //  Ƭѡź
**                      SPI_NSS_Hard                    //  ƬѡźӲ
**
**                      // SPIʷƵѡ
**                      SPI_Baud_Prescaler_2            //  ʷϵΪ2
**                      SPI_Baud_Prescaler_4            //  ʷϵΪ4
**                      SPI_Baud_Prescaler_8            //  ʷϵΪ8
**                      SPI_Baud_Prescaler_16           //  ʷϵΪ16
**                      SPI_Baud_Prescaler_32           //  ʷϵΪ32
**                      SPI_Baud_Prescaler_64           //  ʷϵΪ64
**                      SPI_Baud_Prescaler_128          //  ʷϵΪ128
**                      SPI_Baud_Prescaler_256          //  ʷϵΪ256
**
**                      // λMSBʼǴLSBʼѡ
**                      SPI_First_MSB                   //  MSBȷ
**                      SPI_First_LSB                   //  LSBȷ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void SPIInit(unsigned long ulBase,unsigned long ulConfig)
{
    unsigned long ulTemp;
    
    ulTemp = HWREG32(ulBase + SPI_O_CR1);
    
    ulTemp &= 0x3040; //
    ulTemp |= ulConfig;
    
    /* Write to SPIx CR1 */
    HWREG32(ulBase + SPI_O_CR1) = ulTemp;
  
    /* Activate the SPI mode (Reset I2SMOD bit in I2SCFGR register) */
    HWREG32(ulBase + SPI_O_I2SCFGR) &= ~(0x0800);
    
   /* CRCУĶʽ ,ʱøλ */
    HWREG32(ulBase + SPI_O_CRCPR) = 0x0007;
}

/*********************************************************************************************************
** Function name:       SPI_SSOutEnable
** Descriptions:        SPIƬѡźʹ
** input parameters:    ulBase      SPIģĻַ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void SPI_SSOutEnable(unsigned long ulBase)
{
    HWREG32(ulBase + SPI_O_CR2) |= (1<<2);
}

/*********************************************************************************************************
** Function name:       SPI_SSOutDisable
** Descriptions:        SPIƬѡź
** input parameters:    ulBase      SPIģĻַ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void SPI_SSOutDisable(unsigned long ulBase)
{
    HWREG32(ulBase + SPI_O_CR2) &= ~(1<<2);
}

/*********************************************************************************************************
** Function name:       SPIEnable
** Descriptions:        SPIʹ
** input parameters:    ulBase      SPIģĻַ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void SPIEnable(unsigned long ulBase)
{
    HWREG32(ulBase + SPI_O_CR1) |= (1<<6);
}

/*********************************************************************************************************
** Function name:       SPIDisable
** Descriptions:        SPI
** input parameters:    ulBase      SPIģĻַ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void SPIDisable(unsigned long ulBase)
{
    HWREG32(ulBase + SPI_O_CR1) &= ~(1<<6);
}

/*********************************************************************************************************
** Function name:       SPI_I2S_IntEnable
** Descriptions:        SPII2Sжʹ
** input parameters:    ulBase      SPIģĻַ
**                      ulIntFlag   ʹܵжԴȡֵĵĻ
**                      SPI_I2S_INT_TXE             //  ͻж
**                      SPI_I2S_INT_RXNE            //  ջж
**                      SPI_I2S_INT_ERR             //  ж
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void SPI_I2S_IntEnable(unsigned long ulBase,unsigned long ulIntFlag)
{
    HWREG32(ulBase + SPI_O_CR2) |= ulIntFlag;
}

/*********************************************************************************************************
** Function name:       SPI_I2S_IntEDisable
** Descriptions:        SPII2SжϽ
** input parameters:    ulBase      SPIģĻַ
**                      ulIntFlag   ܵжԴȡֵĵĻ
**                      SPI_I2S_INT_TXE             //  ͻж
**                      SPI_I2S_INT_RXNE            //  ջж
**                      SPI_I2S_INT_ERR             //  ж
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void SPI_I2S_IntEDisable(unsigned long ulBase,unsigned long ulIntFlag)
{
    HWREG32(ulBase + SPI_O_CR2) &= ~ulIntFlag;
}

/*********************************************************************************************************
** Function name:       SPI_I2S_DMAEnable
** Descriptions:        SPII2SDMAģʽʹ
** input parameters:    ulBase      SPIģĻַ
**                      ulDMAFlag   ָʹܵDMAǷͻǽգȥֵĻ
**                      SPI_I2S_DMA_TX               //  DMA
**                      SPI_I2S_DMA_RX               //  DMA
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void SPI_I2S_DMAEnable(unsigned long ulBase,unsigned long ulDMAFlag)
{
    HWREG32(ulBase + SPI_O_CR2) |= ulDMAFlag;
}

/*********************************************************************************************************
** Function name:       SPI_I2S_DMADisable
** Descriptions:        SPII2SDMAģʽ
** input parameters:    ulBase      SPIģĻַ
**                      ulDMAFlag   ָܵDMAǷͻǽգȥֵĻ
**                      SPI_I2S_DMA_TX               //  DMA
**                      SPI_I2S_DMA_RX               //  DMA
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void SPI_I2S_DMADisable(unsigned long ulBase,unsigned long ulDMAFlag)
{
    HWREG32(ulBase + SPI_O_CR2) &= ~ulDMAFlag;
}

/*********************************************************************************************************
** Function name:       SPI_I2S_DataPut
** Descriptions:        SPII2S
** input parameters:    ulBase      SPIģĻַ
**                      usData      ͵ݣ8λģʽʱֻе8λЧ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void SPI_I2S_DataPut(unsigned long ulBase,unsigned short usData)
{
    HWREG32(ulBase + SPI_O_DR) = usData;
}

/*********************************************************************************************************
** Function name:       SPI_I2S_DataPut
** Descriptions:        SPII2S
** input parameters:    ulBase      SPIģĻַ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
unsigned short SPI_I2S_DataGet(unsigned long ulBase)
{
    return (HWREG32(ulBase + SPI_O_DR));
}

/*********************************************************************************************************
  END FILE
*********************************************************************************************************/
