/****************************************Copyright (c)****************************************************
**                                6lowpan߿ƽ̨
**                                  һΪԴӦö
**
**
**--------------File Info---------------------------------------------------------------------------------
** File Name:           arch_io_usart.c
** Last modified Date:  2013-04-02
** Last Version:        v1.0
** Description:         usartuartģĴװʵ
**
**--------------------------------------------------------------------------------------------------------
** Created By:          Renhaiboκ
** Created date:        2013-04-02
** Version:             v1.0
** Descriptions:        The original version ʼ汾
**
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
** Version:
** Description:
**
*********************************************************************************************************/
#include "hal/arch/inc/arch_io_memmap.h"
#include "hal/arch/inc/arch_io_reg.h"
#include "hal/arch/inc/arch_io_usart.h"


/*********************************************************************************************************
** Function name:       UsartConfigSet
** Descriptions:        usartģ
** input parameters:    ulBase  usartģַ
**                      ulClock ṩusartģʱӣusart1ΪAPB2ʱӣ72MΪAPB1ʱӣ36M
**                      ulBaud  ͨŲ,ֱָ
**                      ulConfig ϢȡֵĻ
**                      USART_STOP_0_5          //  0.5λֹͣλ
**                      USART_STOP_1            //  1λֹͣλ
**                      UASRT_STOP_1_5          //  1.5λֹͣλ
**                      USART_STOP_2            //  2λֹͣλ

**                      USART_WLEN_8            //  ֳΪ8
**                      USART_WLEN_9            //  ֳΪ9

**                      USART_PAR_NONE          //  У
**                      USART_PAR_EVEN          //  żУ
**                      USART_PAR_ODD           //  У
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void UsartConfigSet(unsigned long ulBase, unsigned long ulClock, 
                    unsigned long ulBaud, unsigned long ulConfig)
{
    unsigned long ulTemp;
    unsigned long ulIntergerDiv;
    unsigned long ulFloatDiv;
    
    //  ֹͣλüĴCR2
    ulTemp = HWREG32(ulBase + USART_O_CR2);
    ulTemp &= 0xCFFF;
    ulTemp |= (ulConfig << 12);
    HWREG32(ulBase + USART_O_CR2) = ulTemp;
    
    //  üĴCR1ֳУ
    ulTemp = HWREG32(ulBase + USART_O_CR1);
    ulTemp &= 0xE9F3;
    ulTemp |= ulConfig;
    ulTemp |= 0x000C;    //  ʹܷͺͽ
    HWREG32(ulBase + USART_O_CR1) = ulTemp;
    
    //  ע⣺عʱãҪĻӴ
    
    //  ݲʼBRRĴֵд
    //  ȼ
    if((HWREG32(ulBase + USART_O_CR1)) & 0x8000) {
        ulIntergerDiv = ((25 * ulClock) / (2 * ulBaud));
    } else {
        ulIntergerDiv = ((25 * ulClock) / (4 * ulBaud));
    }
    ulTemp = ((ulIntergerDiv / 100) << 4);
    //  С
    ulFloatDiv = ulIntergerDiv - (100*(ulTemp >> 4));
    if((HWREG32(ulBase + USART_O_CR1)) & 0x8000) {
        ulTemp |= ((((ulFloatDiv * 8) + 50) / 100)) & ((unsigned char)0x07);
    } else {
        ulTemp |= ((((ulFloatDiv * 16) + 50) / 100)) & ((unsigned char)0x0F);
    }
    
    HWREG32(ulBase + USART_O_BRR) = ulTemp;
}

/*********************************************************************************************************
** Function name:       UsartEnable
** Descriptions:        usartģʹܣʹܺģ
** input parameters:    ulBase  usartģַ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void UsartEnable(unsigned long ulBase)
{
    HWREG32(ulBase + USART_O_CR1) |= 0x2000;
}

/*********************************************************************************************************
** Function name:       UsartDisable
** Descriptions:        usartģܣܺģֹͣusartǰͨȵøú
** input parameters:    ulBase  usartģַ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void UsartDisable(unsigned long ulBase)
{
    HWREG32(ulBase + USART_O_CR1) &= 0xDFFF;
}


/*********************************************************************************************************
** Function name:       UsartDMAEnable
** Descriptions:        usartģDMAʹ
** input parameters:    ulBase  usartģַ
**                      ulFlags ָʹܵDMAܣȡֵ
**                      USART_DMA_TX    //  DMA͹
**                      USART_DMA_RX    //  DMAܹ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void UsartDMAEnable(unsigned long ulBase,unsigned long ulFlags)
{
  HWREG32(ulBase + USART_O_CR3) |= ulFlags;
}
/*********************************************************************************************************
** Function name:       UsartDMADisable
** Descriptions:        usartģDMAܽ
** input parameters:    ulBase  usartģַ
**                      ulFlags ָܵDMAܣȡֵ
**                      USART_DMA_TX    //  DMA͹
**                      USART_DMA_RX    //  DMAܹ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void UsartDMADisable(unsigned long ulBase, unsigned long ulFlags)
{
  HWREG32(ulBase + USART_O_CR3) &= ~ulFlags;
}
/*********************************************************************************************************
** Function name:       UsartIntEnable
** Descriptions:        usartģжʹ
** input parameters:    ulBase:     usartģַ
**                      ulIntFlags: Ҫʹܵж, гõжϣĿͨĴã
**                                  ȡֵĻ
**                      USART_INT_TX_EMPTY          //  ͻж
**                      USART_INT_TX_FINISH         //  ж
**                      USART_INT_RX                //  жʹܣ˵ռĴ
**                      USART_INT_IDLE              //  IDLEжʹ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void UsartIntEnable(unsigned long ulBase,unsigned long ulIntFlags)
{
    HWREG32(ulBase + USART_O_CR1) |= ulIntFlags;
}

/*********************************************************************************************************
** Function name:       UsartIntEnable
** Descriptions:        usartģжϽ
** input parameters:    ulBase:     usartģַ
**                      ulIntFlags: Ҫܵж, гõжϣĿͨĴã
**                                  ȡֵĻ
**                      USART_INT_TX_EMPTY          //  ͻж
**                      USART_INT_TX_FINISH         //  ж
**                      USART_INT_RX                //  жʹܣ˵ռĴ
**                      USART_INT_IDLE              //  IDLEжʹ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void UsartIntDisable(unsigned long ulBase,unsigned long ulIntFlags)
{
    HWREG32(ulBase + USART_O_CR1) &= ~ulIntFlags;
}

/*********************************************************************************************************
** Function name:       UsartSpaceAvial
** Descriptions:        жϷͼĴǷΪգǷԷһ
** input parameters:    ulBase  usartģַ
** output parameters:   NONE
** Returned value:      true: Էһ falseܷһ
*********************************************************************************************************/
boolean UsartSpaceAvial(unsigned long ulBase)
{
    if (HWREG32(ulBase + USART_O_SR) & 0x0080)
        return true;
    else
        return false;
}

/*********************************************************************************************************
** Function name:       UsartCharPut
** Descriptions:        
** input parameters:    ulBase  usartģַ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void UsartCharPut(unsigned long ulBase,unsigned char ucData)
{
    HWREG32(ulBase + USART_O_DR) = ucData;           //  д뷢ͼĴ
}

/*********************************************************************************************************
** Function name:       UsartCharsAvial
** Descriptions:        жϽռĴǷп
** input parameters:    ulBase  usartģַ
** output parameters:   NONE
** Returned value:      true: ܼĴпݣԶ; false: ռĴ޿
*********************************************************************************************************/
boolean UsartCharsAvial(unsigned long ulBase)
{
    if(HWREG32(ulBase + USART_O_SR) & 0x0020)
        return true;
    else
        return false;
}

/*********************************************************************************************************
** Function name:       UsartCharPut
** Descriptions:        ݣӽռĴж
** input parameters:    ulBase  usartģַ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
unsigned long  UsartCharGet(unsigned long ulBase)
{
    return (HWREG32(ulBase + USART_O_DR) & 0x01FF);   //  ݣ9ΪЧ
}

/*********************************************************************************************************
** Function name:       UsartPutS
** Descriptions:        һַָ
** input parameters:    ulBase: usartģַ
**                      s:      ָ͵ַ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void UsartPutS(unsigned long ulBase,const char *s)
{
    while (*s != '\0') {
       while(!(UsartSpaceAvial(ulBase))) ;          //  ȴͼĴ
       UsartCharPut(ulBase,*(s++));
    }
}
/*********************************************************************************************************
** Function name:       UsartPutS
** Descriptions:        һָȵַ
** input parameters:    ulBase: usartģַ
**                      s:      ַָĻַ
**                      usNum:  ַָĳ
** output parameters:   NONE
** Returned value:      NONE
*********************************************************************************************************/
void UsartPutN(unsigned long ulBase, const  char  *pStr , unsigned short  usNum)
{
    while(usNum) 
    {
        if(UsartSpaceAvial(ulBase))                 //  ͻпռ䣬䷢ͼĴ
        {  
            UsartCharPut(ulBase,*pStr++);
            usNum--;
        }
    }
}

/*********************************************************************************************************
  END FILE
*********************************************************************************************************/
